#ifndef  _ROAD_FUNCTIONS_
#define  _ROAD_FUNCTIONS_  

#include "utility.h"

RoadCoord        pin_x(),pin_y(),
                 pin_dist(), rect_dist(),
                 availableRoomOnDir(),
                 addViaSpacing(),
                 RectCongestion(),
                 rect_size(),
                 spacingBetween(),
                 wire_shift_amount(),
                 additionalSpacing();

Rect             free_neighbor(),
                 follow_Neighbor(),
                 follow_FreeNeighbor(),
                 find_rect();

RoadTerm        *PinIsIn();

RoadCost         connection_cost(),
                 CostFunctionWeight(),
                 TryToEnlarge();

RoadStatus       ElectricallyEquivalent(),
                 IntersectingPaths(),
                 isConnected(),
                 IsPathComplete(),
                 OverlappingPaths(),
                 shield(),
                 wire_SplitAndShift();
RoadWeight       InquireCC_coupling();

pFarad           capacitive_coupling();

micron           Ox_thickness(),
                 Wire_thickness(),
                 layer_distance();

char            *getThePath();

void             add_to_wire(),
                 amplia_rect(),
                 CongestionEstimate(),
                 CreateNetList(),
                 fuseWires(),
                 sub_from_wire(),
                 WireDeleteDuplicates(),
                 WireDeleteOverlap(),
                 WireSegmentToBox();

roadObject       roadObjectType();

EXTERN int
  path_length    ARGS((PATH p));
EXTERN int
  isNetRouted    ARGS((int netNo));

EXTERN void
  rdSetWireMark
  ARGS((int  wn));
EXTERN void
  PruneWire      ARGS((int  wn));
EXTERN void
  roadGeneralCheck();
EXTERN void
  spAddModList   ARGS((int  wn));
EXTERN void
  rdCopyRect
  ARGS((Rect new, Rect old));
EXTERN void
  rdSubFromWire
  ARGS((int  wn, int  pos));

EXTERN PATH
  FullCatPaths   ARGS((PATH a, PATH b));
EXTERN PATH
  BuildPathFromWire ARGS((int   wn));
EXTERN void
  rdGraphicInit
  ARGS((int argc, char **argv));
EXTERN PATH
  rdPathSave     ARGS((PATH new, PATH pth));

EXTERN  char *
  LastDumpFileName  ARGS((char *circuitName));
EXTERN  char *
  NewDumpFileName   ARGS((char *circuitName));

#endif

