/*        OVL.c
 *
 *        Author: Enrico Malavasi
 *        Last revised: December, 1990
 *        Ver. 2.10
 *
 *        Purpose: Capacitive models for overlaying wires.
 */
#include <math.h>
#include "elmacro.h"
#include "rd_types.h"
#include "roadTechnol.h"

/*  -------------------------------------------------------------
 *  Implements the capacitive model for wires running one over the
 *  other.
 */ 
pFarad OVL_XxxModel(d, W1, W2, L)
micron d;              /* Distance between layers        */
micron W1, W2, L;      /* Widths of the wires. Length of the parallel segms. */
{
  
  pFarad x;

/*  ------------------------------------------------------------
 *  Consider only the minimum overlapped area
 */
  x = TECH_OX_DIELECTRIC * min(W1, W2) * L / d;
  return(x);
}
