/*        parallel.c
 *
 *        Author: Enrico Malavasi
 *        Ver. 2.10
 *        Last revised: October, 1990
 *
 *        Purpose: Capacitive models for parallel-running wires.
 */
#include <math.h>
#include "elmacro.h"
#include "rd_types.h"
#include "roadTechnol.h"

#define   CORRECTION   4
/*  --------------------------------------------------------------
 *  Implements the capacitive model for wires running parallel to
 *  each other
 */
pFarad PLL_XxxModel(t, D, W)
micron    t;                 /* Layer thickness             */
micron    D;                 /* Distance                    */
micron    W;                 /* Width of the parallel side  */
{
  pFarad x;

  if(D <= 0) D = 1; /*     TEMPORANEO !!!!!!!! */
  x  = TECH_OX_DIELECTRIC * t * W / D;   /* LINEAR MODEL */
  x  *= CORRECTION;
  return(x);
}
