/*      coord.c
 *
 *	Author: Enrico Malavasi
 *      Ver. 3.10
 *      Last revised: April, 1991
 *
 * 	Purpose: Compute the coordinates of the structures of ROAD
 */
#include "roadGlobals.h"

/*  =========================================================
 *  Respectively compute abscissa and ordinate of a given pin
 */
RoadCoord pin_x(p)
Pins p;
{
    RoadCoord x;

    if(p->cellNo == NOTFOUND)
      x = rRightX(p->rect);
    else
      switch(p->side)  {
	case WEST  :
	  x = cLeftX(cells+p->cellNo) +
	    ((p->cellNo == 0) ? 1 : 0);
	  break;
	case EAST  :
	  x = cRightX(cells+p->cellNo) +
	    ((p->cellNo == 0) ? 0 : 1);
	  break;
	case NORTH :
	case SOUTH :
	  x = cLeftX(cells+p->cellNo) + p->position;
	  default    : break;
      }
    
    if(((p->rect) != NULL) && (x == rLeftX(p->rect)))
      x += 1;
    
    return(x);
}

RoadCoord pin_y(p)
Pins p;
{
    RoadCoord y;
    
    if (p->cellNo == NOTFOUND)
      y = rUpperY(p->rect);
    else
      switch(p->side) {
	case SOUTH :
	  y = cLowerY(cells+p->cellNo) + ((p->cellNo == 0) ? 1 : 0);
	  break;
	case NORTH :
	  y = cUpperY(cells+p->cellNo) + ((p->cellNo == 0) ? 0 : 1);
	  break;
	case EAST  :
	case WEST  :
	  y = cLowerY(cells+p->cellNo) + p->position;
	  default    : break;
      }
    
    if(((p->rect) != NULL) && (y == rLowerY(p->rect)))
      y += 1;
    
    return(y);
}

/*  ============================================================
 *  Return the distance between two rects
 */
RoadCoord rect_dist(r1,r2)
Rect r1, r2;
{
    RoadCoord x,y;
    
    x = rRightX(r1) - rRightX(r2);
    y = rUpperY(r1) - rUpperY(r2);
    return(abs(x) + abs(y));
}

/*  ===================================================================
 *  This function Returns the size of a given rect in a given direction
 *  The value returned is:
 *     the rheight of <r> if (side==NORTH  or  side==SOUTH)
 *     the rwidth of  <r> if (side==EAST   or  side==WEST)
 *  else   NOTFOUND is returned.
 */
RoadCoord
  rect_size(r, side)
Rect r;
int  side;
{
    if north_or_south(side)    return(rheight(r));
    if east_or_west(side)      return(rwidth(r));

    return(NOTFOUND);
}

DualDir(dir)
int dir;
{
    switch(dir) {
      case NORTH:    return(EAST);
      case EAST :    return(NORTH);
      case SOUTH:    return(WEST);
      case WEST :    return(SOUTH);
	default   :    return(dir);
    }
}
AbsDualDir(dir)
int dir;
{
    switch(dir) {
      case NORTH:
      case SOUTH:    return(EAST);
      default:       return(NORTH);
    }
}
