/*     files.c
 *
 *     Author: Enrico Malavasi,  University of Bologna, Italy
 *     Ver. 1.00    -     August, 1989
 *
 *     Purpose: Management of the dump files.
 */
#include  "port.h"
#include  "utility.h"
#define    DMP_EXTENSION     "dmp"

FILE    *fp, *fopen();

/*  ============================================================
 *  Generate the name for a new dump file
 */
char *
  NewDumpFileName( circuitName )
char *circuitName;              /*  Input:  circuit name  */
{
    int counter;
    char *FileName;                 /*  Output: file name     */
    
    FileName = ALLOC(char, strlen(circuitName)+strlen(DMP_EXTENSION)+6);
    for(counter=0 ; ; counter++) {
	sprintf(FileName, "%s.%s%d", circuitName, DMP_EXTENSION, counter);
	if((fp=fopen(FileName, "r")) == NULL)  return FileName;
	fclose(fp);
    }
}

/*  ============================================================
 *  Generate the name of the most recent existing dump file
 */
char
  *LastDumpFileName( circuitName )
char *circuitName;              /*  Input:  circuit name  */
{
    int counter;
    char *FileName;

    FileName = ALLOC(char, strlen(circuitName)+strlen(DMP_EXTENSION)+6);
    for(counter=0 ; ; counter++) {
	sprintf(FileName, "%s.%s%d", circuitName, DMP_EXTENSION, counter);
	if((fp=fopen(FileName, "r")) == NULL) {
	    sprintf(FileName, "%s.%s%d", circuitName, DMP_EXTENSION, --counter);
	    return FileName;
	}
	fclose(fp);
    }
}

/*  ------------------------------------------------------------
 *  Return the path of the given file
 */
char
*getThePath(name)
char *name;
{
  char path[128];
  int  l;

  strcpy(path, name);
  l = strlen(path);
  while(l > 0)
    if(path[--l] == '/')
      break;

  path[l] = '\0';
  return(path);
}
