/*      followside.c
 *
 *      Author: Enrico Malavasi
 *      Ver. 2.10
 *      Last revised: September, 1990
 *
 *      Purpose: Follow the neighborhood from a given rectangle in
 *               a direction, until possible.
 */
#include "roadGlobals.h"

/*  ============================================================
 *  The neighborhood is limited to the free field.
 */
Rect
follow_FreeNeighbor(r, side)
Rect r;                   /* Beginning rectangle */
int  side;                /* Side | direction    */
{
  Rect s, p;

  s = r;
  while((p=free_neighbor(s, side)) != NULL)
    s = p;
  return(s);
}

/*  ============================================================
 *  The neighborhood is exactly considered.
 */
Rect
follow_Neighbor(r, side)
Rect r;                   /* Beginning rectangle */
int  side;                /* Side | direction    */
{
  Rect s, p;

  s = r;
  while((p=neighbor(s, side)) != NULL)
    s = p;
  return(s);
}
