/*     graph.h
 *
 *     Author: Enrico Malavasi
 *     Ver. 3.20    -    August 1991
 *
 *     INCLUDE FILE for the graphic utilities of ROAD.
 */
#ifndef  _ROAD_GRAPH_
#define  _ROAD_GRAPH_
#include "port.h"
#include "roadGlobals.h"

typedef   unsigned long   RoadColor;
typedef struct {
  RoadColor  BackGround;             /* Background color ... */
  RoadColor  Obstacles;              /* Obstacles color .... */
  RoadColor  HighLight;              /* HighLight color */
  RoadColor *layer_color;            /* Colors for layers.   */
} ColorSet;

#define     MAINFRAME_     0
#define     PARAFRAME_     1

/*  ============================================================
 *  X version 1.1
 */
#include  <X11/X.h>
#include  <X11/Xlib.h>

#ifdef FIRSTXDEF
Display              MAINDisplay;
GC                   MAINGc, PARAGc;
Colormap             MAINColormap;
Window               ROADWindow,
                     MAINWindow,
                     PARAWindow;
ColorSet             color_set;
Cell                 rdView;
int                  ZX0, ZY0, ZX1, ZY1;
float                ZDX, ZDY;
#else
extern Display       MAINDisplay;
extern GC            MAINGc, PARAGc;
extern Colormap      MAINColormap;
extern Window        ROADWindow,
                       MAINWindow,
                       PARAWindow;
extern ColorSet      color_set;
extern Cell          rdView;
extern int           ZX0, ZY0, ZX1, ZY1;
extern float         ZDX, ZDY;
#endif

/*  ------------------------------------------------------------
 *  Macros
 */
#define   Xcorrect(x)         ((int) (((x)-rdView.x1)*ZDX + ZX0))
#define   Xuncorrect(x)       ((RoadCoord) (((x)-ZX0)/ZDX + rdView.x1))
#define   Ycorrect(y)         ((int) ((rdView.y2-(y))*ZDY + ZY0))
#define   Yuncorrect(y)       ((RoadCoord) ((ZY0-(y))/ZDY + rdView.y2))
#define   set_layer_color(l) \
      set_color(((l)<0) ? color_set.Obstacles : color_set.layer_color[l])

#define  set_color(i)   XSetForeground(&MAINDisplay, MAINGc, i)
#define  RoadSync(f)    XSync(&MAINDisplay, f)

#endif
