/*      nodeto.c
 *
 *      Author: Enrico Malavasi
 *      Ver. 2.10
 *      Last revised: September, 1990
 *
 *      Purpose: Conversion utilities
 */
#include "roadGlobals.h"

static int i;    /*   local loop counter   */

/*  ============================================================
 *  Convert a net index to a wire index. Since two or more wires
 *  can be associated with one net, the <first> parameter indicates
 *  which is the first wire to be considered.
 */
net_to_wire(netNo, first)
int netNo,
    first;        /* First item to be considered */
{
    for(i=first ; i<WIRE_NUM ; i++)
      if(wireNetNo(i) == netNo)      return(i);
    return(NOTFOUND);
}

name_to_net(name)
char *name;
{
  int i;
  for(i=0 ; i<NET_NUM ; i++)
    if(rd_net[i].name[0] != NULL)
      if(strcasecmp(rd_net[i].name, name) == 0)
	return(i);
  return(NOTFOUND);
}
