/*    savedata.c
 *
 */
#include "port.h"
#include "utility.h"
#include "roadGlobals.h"

#define   TEMPFILE  "/tmp/road"

static  FILE    *TempFil;
static  int      i;
static  PathName filename;

SaveMirrData()
{
    sprintf(filename, "%s_%d", TEMPFILE, getpid());
    if((TempFil=fopen(filename, "w")) == NULL) {
	fprintf(stderr, "Couldn't write the temporary file %s", filename);
	exit( 1 );
    }
    VERBOSE( printf("Creating temporary file %s\n", filename));
    
    i = PIN_NUM;
    fwrite(&i, sizeof(int), 1, TempFil);
    fwrite(pins, sizeof(pins[0]), PIN_NUM, TempFil);
    
    i = SUB_CELL_NUM;
    fwrite(&i, sizeof(int), 1, TempFil);
    fwrite(cells, sizeof(cells[0]), SUB_CELL_NUM+1, TempFil);
    
    fclose(TempFil);
}

ReadMirrData()
{
    char unixMess[128];

    sprintf(filename, "%s_%d", TEMPFILE, getpid());
    if((TempFil=fopen(filename, "r")) == NULL) {
	fprintf(stderr, "Couldn't read the temporary file %s", filename);
	rdExit( 1 );
    }
    
    fread(&i, sizeof(int), 1, TempFil);
    PIN_NUM = i;
    pins = REALLOC(RoadTerm, pins, i);
    fread(pins, sizeof(pins[0]), PIN_NUM, TempFil);
    ForAllPins(i)
      pins[i].rect = NULL;
    
    fread(&i, sizeof(int), 1, TempFil);
    SUB_CELL_NUM = i;
    fread(cells, sizeof(cells[0]), SUB_CELL_NUM+1, TempFil);
    
    fclose(TempFil);
    VERBOSE( printf("Deleting temporary file %s\n", filename));
    sprintf(unixMess, "rm -f %s", filename);
    system( unixMess );
}


