/*      sheet.c
 *
 *      Purpose: Management of a saving sheet.
 *      Author: Enrico Malavasi
 *      Ver. 3.20
 *      Last revised: September, 1990
 */
#include "port.h"
#include  "utility.h"
#include  "roadGlobals.h"

static   Pins      PinSheet = NULL;
static   RoadNet  *NetSheet = NULL;

/*  ==================================================================
 *  Creation or updating of the PinSheet list. In the restore function
 *  net matching is checked on the permanent list, not on the
 *  working copy.
 */
CreatePinSheetList()
{
    int i;

    PinSheet = REALLOC(RoadTerm, PinSheet, PIN_NUM);
    NetSheet = REALLOC(RoadNet,  NetSheet, NET_NUM);
    ForAllPins(i)
      PinSheet[i] = pins[i];
    ForAllNets( i )
      NetSheet[i] = rd_net[i];
}
RestorePinSheetList(lostNet)
int lostNet;
{
    int i;

    ForAllPins(i)             /*  Save the pins  */
      if((lostNet == NOTFOUND) || (PinSheet[i].netNo == lostNet)) {
	  pins[i] = PinSheet[i];
      }
    if(lostNet != NOTFOUND)  rd_net[lostNet] = NetSheet[lostNet];
}

ShiftPinSheetRects(shft)
int shft;
{
    char *s;
    int  i;

    if(PinSheet == NULL) return;
    ForAllPins(i) {
	s = (char *) PinSheet[i].rect;
	s += shft;
	PinSheet[i].rect = (Rect) s;
    }
}

UpdateSheetRects(netNo)
int netNo;
{
    int i;

    ForAllPins(i)             /*  Save the pins  */
      if((netNo == NOTFOUND) || (PinSheet[i].netNo == netNo))
	PinSheet[i].rect = pins[i].rect;
}
