#include "roadGlobals.h"
#include "space.h"

static RoadCoord minwdt;

static void collMinSize()
{
  int i;
  RoadCoord wdt;

  minwdt = 0;
  for(i=0 ; i<LAYER_NUM ; i++) {
    wdt = regNeededSpacing(i)+addViaSpacing(i);
    if(wdt > minwdt) minwdt = wdt;
  }
}

arePinsHere(r)
Rect r;
{
  int i;
  ForAllPins(i)
    if(pins[i].rect == r) return(i);
  return(NOTFOUND);
}

collapseGrid(r, dir)
Rect  r;
int   dir;   /*  collapsing dir (> 0) */
{
  int i, j;
  RoadCoord Y, diff;

  Y = r->y2;
  dir = abs(dir);
  collMinSize();

  if(dir == NORTH) {
    diff =  rheight(r) - minwdt;
    cells[0].y2 -= diff;
    for(i=1 ; i<=SUB_CELL_NUM ; i++)
      if(cells[i].y1 >= Y) {
	cells[i].y1 -= diff;
	cells[i].y2 -= diff;
	for(j=1 ; j<i ; j++)
	  if(cells[j].instanceNo == cells[i].instanceNo)
	    break;
	if(j == i)
	  insts[cells[i].instanceNo].y -= diff;
      }
    ForAllRects(i)
      if(rects[i].y2 >= Y) {
	rects[i].y2 -= diff;
	if(rects[i].y1 >= Y)
	  rects[i].y1 -= diff;
      }
    ForAllPins(i)
      if(pins[i].cellNo == 0)
	if(abs(pins[i].side) == EAST)
	  if((pins[i].position-cells[0].y1) >= Y)
	    pins[i].position -= diff;
  }
}

shrinkGrid()
{
  int i, l;
  Rect r, s;
  RoadBox BB;

  collMinSize();

  BB.x1 = cells[0].x2;
  BB.y1 = cells[0].y2;
  BB.x2 = cells[0].x1;
  BB.y2 = cells[0].y1;
  ForAllWires(i)
    for(l=0 ; (r=wSegmRect(i, l))!=NULL ; l++) {
	if(r->x2 < BB.x1) BB.x1 = r->x2;
	if(r->x2 > BB.x2) BB.x2 = r->x2;
	if(r->y2 < BB.y1) BB.y1 = r->y2;
	if(r->y2 > BB.y2) BB.y2 = r->y2;
    }

  ForAllRects(i)
    if((rects[i].x1 == cells[0].x1) &&
       (rects[i].layer == 0))  {
      r = rects+i;
      if(rheight(r) <= minwdt)  continue;
      if(r->y2 <= BB.y1) continue;
      if(r->y2 >  BB.y2) continue;
      for(l=0 ; l<LAYER_NUM ; l++) {
	s = follow_Neighbor(r, EAST);
	if(s->x2 < cells[0].x2)
	  break;
	r = neighbor(r, UP);
      }
      if(l < LAYER_NUM) continue;

      collapseGrid(rects+i, NORTH);
    }
}

canShrink(r, dir)
Rect  r;
int   dir;
{
  int  adir;

  adir = AbsDualDir(dir);
  while(rLayer(r) > 0)
    if((r=neighbor(r, DOWN)) == NULL) return(NO);

  while(rLayer(r) < LAYER_NUM) {
    r = follow_Neighbor(r, -adir);
    if((adir == EAST)  && (rLeftX(r) != cLeftX(cells)))   return(NO);
    if((adir == NORTH) && (rLowerY(r) != cLowerY(cells))) return(NO); 
    if(arePinsHere(r))  return(NO);
    r = follow_Neighbor(r, adir);
    if((adir == EAST)  && (rRightX(r) != cRightX(cells)))   return(NO);
    if((adir == NORTH) && (rUpperY(r) != cUpperY(cells)))   return(NO);
    if((r=neighbor(r, UP)) == NULL)   return(NO);
    if(arePinsHere(r))  return(NO);
  }
  return(YES);
}
