/*      symmlist.c
 *
 *      Purpose: Management of a symmetry list.
 *      Author: Enrico Malavasi
 *      Ver. 3.20
 *      Last revised: August 1991
 */
#include "port.h"
#include  "utility.h"
#include  "roadGlobals.h"

typedef struct _symmList {
    int  net1;
    int  net2;
} _symmList;
static _symmList      *SymmetryList     = NULL;
static int             SymmetryListSize = 0;
static unsigned int    SymmetryFlag     = NO;

AddToSymmetryList(net1, net2)
int net1, net2;
/*  Add a new item to the symmetry list.  */
{
    SORT(int, net1, net2);
    SymmetryList = REALLOC(_symmList, SymmetryList, SymmetryListSize+1);
    SymmetryList[SymmetryListSize].net1   = net1;
    SymmetryList[SymmetryListSize++].net2 = net2;
}

InquireSymmetryList(NetNo)
int NetNo;
/*  Inquire for an item in the symmetry list. This function
 *  returns the symmetric partner of a given net.           */
{
    int i;

    for(i=0 ; i<SymmetryListSize ; i++) {
	if(SymmetryList[i].net1 == NetNo)   return(SymmetryList[i].net2);
	if(SymmetryList[i].net2 == NetNo)   return(SymmetryList[i].net1);
    }
    return(NOTFOUND);
}

/*  ============================================================
 *  This function returns the next unrouted element with a
 *  symmetry specification.
 */
NextUnroutedSymm()
{
  int i;

  for(i=0 ; i<NET_NUM ; i++)
    if(InquireSymmetryList(i) != NOTFOUND)
      if(InquireNetList(i) != NOTFOUND)
	return(i);
  return(NOTFOUND);
}

GetSymmetryListSize()   {   return(SymmetryListSize);  }
SetSymmetryFlag(f) 
int f;
{   if(status.General & GEN_SYMM)  SymmetryFlag = f;  }
GetSymmetryFlag()       {   return(SymmetryFlag);  }
