#include  "rd_types.h"
#include  "elmacro.h"

/*  ------------------------------------------------------------
 *  Technology parameters and access functions.
 */
micron
layer_distance(l1, l2)  /* Vertical spacing between layers ........ */
int  l1, l2;
{
  if(l2 < l1) SWAP(int, l1, l2);
  if((l1 == 0) && (l2 == 1))
    return((micron) 0.6);
  if((l1 == 1) && (l2 == 2))
    return((micron) 0.8);
  if((l1 == 0) && (l2 == 2))
    return((micron) 1.4);
}

micron
Ox_thickness(layerNo)  /* Vertical spacing between a layer and bulk */
int layerNo;
{
  switch(layerNo) {
  case 0 :
    return((micron) 0.8);
  case 1 :
    return((micron) 1.2);
  case 2 :
  default:
    return((micron) 2.4);
  }
}

micron
Wire_thickness(layerNo) /* Wire thickness ......................... */
int layerNo;
{ 
  return((micron) 0.6);
}

