#include "copyright.h"
#include "port.h"
#include "rpc.h"

char *optProgName = "demon";

/*ARGSUSED*/  
int
testExit(spot, cmdList, userOptionWord)
RPCSpot *spot;
lsList cmdList;
long userOptionWord;
{
    RPCExit(0);
    return RPC_OK;
}


RPCFunction CommandArray[] = {
	{testExit, "demon", "exit", "X", 10},
};


void
printCL(cl)
octObject *cl;
{
    octObject facet, obj, cr;
    octGenerator gen;

    octInitGenContents(cl, OCT_ALL_MASK, &gen);
    while (octGenerate(&gen, &cr) == OCT_OK){
	octGetFacet(cl, &facet);
	if (octGetByExternalId(&facet, cr.contents.changeRecord.objectExternalId, &obj) == OCT_OK) {
	    fprintf(stderr, "\t%s\n", ohFormatName(&obj));
	} else if (octGenFirstContent(&cr, OCT_ALL_MASK, &obj) == OCT_OK) {
	    fprintf(stderr, "\t%s\n", ohFormatName(&obj));
	} else {
	    fprintf(stderr, "\tunknown object\n");
	}
    }
    return;
}


void bob();
void fred();

void
bob(cl)
octObject *cl;
{
    octObject facet, changeList;

    fprintf(stderr, "bob (layer) here...\n");
    printCL(cl);

    octGetFacet(cl, &facet);
    octDelete(cl);

    changeList.type = OCT_CHANGE_LIST;
    changeList.contents.changeList.objectMask = OCT_LAYER_MASK;
    changeList.contents.changeList.functionMask = OCT_ALL_FUNCTION_MASK;
    octCreate(&facet, &changeList);
    RPCRegisterDemon(&changeList, bob);

    return;
}
		  

void
fred(cl)
octObject *cl;
{
    octObject facet, changeList;

    fprintf(stderr, "fred (instance) here...\n");
    printCL(cl);

    octGetFacet(cl, &facet);
    octDelete(cl);

    changeList.type = OCT_CHANGE_LIST;
    changeList.contents.changeList.objectMask = OCT_INSTANCE_MASK;
    changeList.contents.changeList.functionMask = OCT_ALL_FUNCTION_MASK;
    octCreate(&facet, &changeList);
    RPCRegisterDemon(&changeList, fred);

    return;
}

/*ARGSUSED*/
int
UserMain(display, spot, cmdList, userOptionWord, array)
char *display;
RPCSpot *spot;
lsList cmdList;
long userOptionWord;
RPCFunction *array[];
{
    octObject facet, changeList;

    facet.objectId = spot->facet;
    octGetById(&facet);

    changeList.type = OCT_CHANGE_LIST;
    changeList.contents.changeList.objectMask = OCT_LAYER_MASK;
    changeList.contents.changeList.functionMask = OCT_ALL_FUNCTION_MASK;
    octCreate(&facet, &changeList);
    RPCRegisterDemon(&changeList, bob);

    changeList.type = OCT_CHANGE_LIST;
    changeList.contents.changeList.objectMask = OCT_INSTANCE_MASK;
    changeList.contents.changeList.functionMask = OCT_ALL_FUNCTION_MASK;
    octCreate(&facet, &changeList);
    RPCRegisterDemon(&changeList, fred);

    *array = CommandArray;
    VEMMSG("Demon initialized\n");
    vemPrompt();
    return(sizeof(CommandArray) / sizeof(RPCFunction));
}

