#include "copyright.h"
#include "st.h"

#define CHECK_SAME(x, y, str)	\
    if ((x) != (y)) {							\
	errRtn = (str);							\
	return(E_NOTFOUND);						\
    }

#define CHECK_CKT(cktPtr)	CHECK_SAME((cktPtr), deckCurrentCkt,	\
						"not current circuit")

#define CHECK_DEV(devType)	\
    if ((devType) < 0 || (devType) >= deckInfo.numDevices) {		\
	errRtn = "nonexistent device type";				\
	return(E_NOTFOUND);						\
    }

struct nameSpace {
    st_table *nameTable;	/* name => IFuid */
    char *prefix;		/* for generated names */
    int counter;		/* for making unique names */
    int doPrefix;		/* =1 means use prefix even for given names */
};

struct model {
    IFdevice *devPtr;
    char magicChar;
    IFuid modelUid;
    char *name;
};

/* XXX -- we blur the boundary between the front end and `simulator' */
#define NAME_OF_UID(uid)	ofeNameOf(uid)
#define CKT_NAME_OF_UID(uid)	ofeCktNameOf(uid)
#define DECK_STREAM		ofeDeckStream
extern char *ofeNameOf(/* IFuid uid */);
extern char *ofeCktNameOf(/* IFuid uid */);
extern FILE *ofeDeckStream;
