#include "copyright.h"
#include "port.h"
#include <setjmp.h>
#include "utility.h"
#include "oct.h"
#include "oh.h"
#include "octspice.h"

static jmp_buf intJmpBuf;

int ofeDisplayDialog(dlgPtr)
struct dialog *dlgPtr;
{
    void (*oldSigHandler)();
    int nCols;
    int colSize;
    int i;
    static struct flagStruct reEdit = { "re-edit" };
    void queryFlag(), queryScalar();
    void interrupt();

    (void) printf("\t\t%s\n\t(Ctrl-C to abort operation)\n\n", dlgPtr->title);

    oldSigHandler = signal(SIGINT, interrupt);
    if (setjmp(intJmpBuf)) {
	(void) signal(SIGINT, oldSigHandler);
	return(0);
    }

    do {
	/* handle the flag options */
	nCols = daLen(dlgPtr->flagColTitles);
	if (nCols > 0) {
	    colSize = (daLen(dlgPtr->flags) + nCols - 1) / nCols;
	}

	for (i = 0; i < daLen(dlgPtr->flags); i++) {
	    if ((nCols > 0) && (i % colSize == 0)) {
		(void) printf("\t%s\n",
			      *daGet(char *, dlgPtr->flagColTitles, i/colSize));
	    }
	    queryFlag(daGet(struct flagStruct, dlgPtr->flags, i));
	}

	/* handle the scalar options */
	for (i = 0; i < daLen(dlgPtr->scalars); i++) {
	    queryScalar(daGet(struct scalarStruct, dlgPtr->scalars, i));
	}

	/* handle the array options */
	for (i = 0; i < daLen(dlgPtr->arrays); i++) {
	    /* XXX */
	}

	reEdit.flag = 0;
	queryFlag(&reEdit);
    } while (reEdit.flag);

    (void) signal(SIGINT, oldSigHandler);

    return(1);
}

static void queryFlag(flagPtr)
struct flagStruct *flagPtr;
{
    char lineBuf[BUFSIZ];

    do {
	(void) printf("%s [%c]? ", flagPtr->name, flagPtr->flag ? 'y' : 'n');
	if (fgets(lineBuf, sizeof(lineBuf)/sizeof(char), stdin) == NULL ||
					strcmp(lineBuf, "\n") == 0) {
	    return;
	}
    } while (lineBuf[0] != 'y' && lineBuf[0] != 'n');

    flagPtr->flag = (lineBuf[0] == 'y');
}

static void queryScalar(scalarPtr)
struct scalarStruct *scalarPtr;
{
    char lineBuf[BUFSIZ];

    do {
	(void) printf("%s [%g]? ", scalarPtr->name, scalarPtr->value);
	if (fgets(lineBuf, sizeof(lineBuf)/sizeof(char), stdin) == NULL ||
					strcmp(lineBuf, "\n") == 0) {
	    return;
	}
    } while (sscanf(lineBuf, "%lg", &scalarPtr->value) != 1);
}

static void interrupt()
{
    longjmp(intJmpBuf, 1);
}
