#include "copyright.h"

struct termMap {
    char *octName;	/* name of terminal in oct facet */
    char *simName;	/* name of terminal as known by simulator */
};

struct instParms {
    char *octName;	/* name of parameter on oct facet and/or instance */
    char *simName;	/* name of simulator instance parameter */
    enum _mixType { INST_OVERRIDE, INST_RATIO } mastInstMix;
			/* does prop on instance override or get divided by
			 * prop on master */
};

struct deviceMap {
    char *octCellType;	/* value of oct CELLTYPE property */
    char *modBagName;	/* name of top level model bag */

    char *octSubName;	/* name (if any) of subtype property (eg SOURCETYPE) */
    char *octSubType;	/* value of subtype property */
    char *octPropName;	/* name (if any) of model property (eg level) */
    char *octPropType;	/* value of model property */

    char *simDevice;	/* simulator name for device */
    void (*except)();	/* function to handle exceptional cases */
    int nTerms;		/* terminal correspondence */
    struct termMap *terms;
    int nIParms;	/* instance parameter correspondence */
    struct instParms *iParms;
};

extern struct deviceMap ofeTransTable[];
