#include	"piftooct.h"
#include	"y.tab.h"

static	SymbolEntry	*SymbolTable= 0;
static	ComboEntry	*ComboTable= 0;
static	ClockEntry	*ClockTable= 0;
static	IOEntry		*IEntry= 0;
static	IOEntry		*OEntry= 0;
static	CIOEntry	*CIEntry= 0;
static	CIOEntry	*COEntry= 0;
static	OutEntry	*OutTable= 0;

/******************************************************/

ComboEntry	*CreateCEntry(ename, efanin, efanout)
char	*ename;
int	efanin, efanout;
{
	ComboEntry	*p;
	char		*emalloc();

	p= (ComboEntry *) emalloc( sizeof(ComboEntry) );
	p->signame= emalloc( strlen(ename)+1 );
	strcpy(p->signame, ename);
	p->fanin= efanin;
	p->fanout= efanout;
	p->next= ComboTable;
	ComboTable= p;
	return p;
}

/******************************************************/

SymbolEntry	*CreateEntry(ename, efanin, efanout)
char	*ename;
int	efanin, efanout;
{
	SymbolEntry	*p;
	char		*emalloc();

	p= (SymbolEntry *) emalloc( sizeof(SymbolEntry) );
	p->signame= emalloc( strlen(ename)+1 );
	strcpy(p->signame, ename);
	p->fanin= efanin;
	p->fanout= efanout;
	p->next= SymbolTable;
	SymbolTable= p;
	return p;
}

/******************************************************/

ComboEntry	*FindCEntry(ename)
char	*ename;
{
	ComboEntry	*p;

	for ( p= ComboTable; p!= (ComboEntry *) 0; p= p->next )
		if ( strcmp(p->signame, ename)== 0 )
			return p;
	return 0;
}

/******************************************************/

IOEntry	*FindOutEntry(ename)
char	*ename;
{
	IOEntry	*p;

	for ( p= OEntry; p!= (IOEntry *) 0; p= p->next )
		if ( strcmp(p->ioname, ename)== 0 )
			return p;
	return 0;
}

/******************************************************/

SymbolEntry	*FindEntry(ename)
char	*ename;
{
	SymbolEntry	*p;

	for ( p= SymbolTable; p!= (SymbolEntry *) 0; p= p->next )
		if ( strcmp(p->signame, ename)== 0 )
			return p;
	return 0;
}

/*******************************************************/

char	*emalloc(n)
unsigned	n;
{
	char	*p, *malloc();

	p= malloc(n);
	if ( p==0 )
	{
		printf("Out of Memory; malloc() failed.\n");
		exit(1);
	}
	return p;
}

/*******************************************************/

int symprint()
{
	SymbolEntry	*p;

	p= SymbolTable;
	while ( p!= (SymbolEntry *) 0 )
	{
		printf("E-->%s %d %d \n", p->signame, p->fanin, p->fanout);
		p= p->next;
	}
}

/*******************************************************/

void make_an_input(aname)
     char *aname;
     /* Declares aname to be an input. */
{
/*
  IOEntry *ioe;

  ioe= (IOEntry *) emalloc( sizeof(IOEntry) );
  ioe->ioname= aname;
  ioe->next= IEntry;
  IEntry= ioe;
*/
}

void make_a_clock(aname)
     char *aname;
     /* Declares aname to be an input. */
{
}

ComboEntry *CInputs()
{
	ComboEntry	*p;
	CIOEntry		*ioe, *iof;

	p= ComboTable;
	while ( p!= (ComboEntry *) 0 )
	{
		if (p->fanout==0) 
		{
			ioe= (CIOEntry *) emalloc( sizeof(CIOEntry) );
			ioe->ioname= p->signame;
			ioe->next= CIEntry;
			CIEntry= ioe;
		}
		p= p->next;
	}
/*
	iof= CIEntry;
	while ( iof!= (CIOEntry *) 0 )
	{
		printf("CI-->%s\n", iof->ioname);
		iof= iof->next;
	}
*/
}

/*******************************************************/

SymbolEntry *Inputs()
{
	SymbolEntry	*p;
	IOEntry		*ioe, *iof;

/* #if FALSE */
	p= SymbolTable;
	while ( p!= (SymbolEntry *) 0 )
	{
		if (p->fanout==0) 
		{
			ioe= (IOEntry *) emalloc( sizeof(IOEntry) );
			ioe->ioname= p->signame;
			ioe->next= IEntry;
			IEntry= ioe;
		}
		p= p->next;
	}
/* #endif */
/*
	iof= IEntry;
	while ( iof!= (IOEntry *) 0 )
	{
		printf("I-->%s\n", iof->ioname);
		iof= iof->next;
	}
*/
}

/*******************************************************/

void make_an_output(aname)
     char *aname;
     /* Declares aname to be an output. */
{
  OutEntry *oe;

  oe= (OutEntry *) emalloc( sizeof(OutEntry) );
  oe->outname= aname;
  oe->next= OutTable;
  OutTable= oe;
}

ComboEntry *COutputs()
{
	ComboEntry	*p;
	CIOEntry		*ioe, *iof;

	p= ComboTable;
	while (p!= (ComboEntry *) 0 )
	{
		if (p->fanin==0)
		{
			ioe= (CIOEntry *) emalloc( sizeof(CIOEntry) );
			ioe->ioname= p->signame;
			ioe->next= COEntry;
			COEntry= ioe;
		}
		p= p->next;
	}
/*
	iof= COEntry;
	while ( iof!= (CIOEntry *) 0 )
	{
		printf("CO-->%s\n", iof->ioname);
		iof= iof->next;
	}
*/
}

/*******************************************************/

SymbolEntry *Outputs()
{
	SymbolEntry	*p;
	IOEntry		*ioe, *iof;

/* #if FALSE */
	p= SymbolTable;
	while ( p!= (SymbolEntry *) 0 )
	{
		if (p->fanin==0)
		{
			ioe= (IOEntry *) emalloc( sizeof(IOEntry) );
			ioe->ioname= p->signame;
			ioe->next= OEntry;
			OEntry= ioe;
		}
		p= p->next;
	}
/* #endif */
/*
	iof= OEntry;
	while ( iof!= (IOEntry *) 0 )
	{
		printf("O-->%s\n", iof->ioname);
		iof= iof->next;
	}
*/
}

/*******************************************************/

int WriteBlifTemp()
{
	CIOEntry	*ioe, *iof;

	fprintf(ftempblif, ".model %s\n", tname);
	fprintf(ftempblif, ".inputs ");
	ioe= CIEntry;
	while ( ioe!= (CIOEntry *) 0 )
	{
		fprintf(ftempblif,"%s ", ioe->ioname);
		ioe= ioe->next;
	}
	fprintf(ftempblif, "\n.outputs ");
	iof= COEntry;
	while ( iof!= (CIOEntry *) 0 )
	{
		fprintf(ftempblif,"%s ", iof->ioname);
		iof= iof->next;
	}
	fprintf(ftempblif, "\n");
}
/*******************************************************/

int WriteTemp()
{
	IOEntry		*ioe, *iof;
	OutEntry	*ioout;
	ClockEntry	*ioc;

	fprintf(fbdnet, "ENDMODEL;\n");
	fprintf(ftemp, "MODEL %s:memory;\n", tname);
	fprintf(ftemp, "\tTECHNOLOGY scmos;\n");
	fprintf(ftemp, "\tINPUT");
	ioe= IEntry;
	while ( ioe!= (IOEntry *) 0 )
	{
		fprintf(ftemp," %s", ioe->ioname);
		ioe= ioe->next;
	}
	fprintf(ftemp, ";\n\tOUTPUT");
/* Make change for including extra output lines from OutEntry */
	ioout= OutTable;
	while ( ioout!= (OutEntry *) 0 )
	{
		if ( FindOutEntry(ioout->outname)==(IOEntry *) 0 )
			fprintf(ftemp," %s", ioout->outname);
		ioout= ioout->next;
	}
/* Up to here */
	iof= OEntry;
	while ( iof!= (IOEntry *) 0 )
	{
		fprintf(ftemp," %s", iof->ioname);
		iof= iof->next;
	}
	fprintf(ftemp, ";\n\tSUPPLY vdd;\n\tGROUND gnd;\n\tCLOCK");
	ioc= ClockTable;
	while ( ioc!= (ClockEntry *) 0 )
	{
		fprintf(ftemp," %s", ioc->cname);
		ioc= ioc->next;
	}
	fprintf(ftemp, ";\n\n");
	fprintf(ftemp, "\tINSTANCE %s:logic PROMOTE;\n\n", tname);
}

/*******************************************************/

ClockEntry	*CreateClock(ename)
char	*ename;
{
	ClockEntry	*p;
	char		*emalloc();

	p= (ClockEntry *) emalloc( sizeof(ClockEntry) );
	p->cname= emalloc( strlen(ename)+1 );
	strcpy(p->cname, ename);
	p->next= ClockTable;
	ClockTable= p;
	return p;
}

/******************************************************/

ClockEntry	*FindClock(ename)
char	*ename;
{
	ClockEntry	*p;

	for ( p= ClockTable; p!= (ClockEntry *) 0; p= p->next )
		if ( strcmp(p->cname, ename)== 0 )
			return p;
	return 0;
}

/*******************************************************/
