%{
#include	"pre.h"
%}
%union {
	char	*yname;
	char	yops;
	char    yio;
	char	*yseqops;
}
%token	<yname> NAME
%token	<yops>  EQL NOTEQL ENDUM
%token	<yseqops>  SNOTEQL1 SNOTEQL2
%token  <yio> INDECL OUTDECL CLKDECL
%type	<yname> equentry centry input1list input2list input3list result
%type	<yname> sentry dtinput jrinput sequin clock seqout
%type	<yops>  op opnot telos
%type	<yseqops> seqop seqdop
%%
entrylist :	{   }
	| entrylist equentry {   }
	| entrylist sentry {   }
	| entrylist centry {   }
	| entrylist declentry {   }
	| entrylist error { yyerror(); }
	;
centry	: opnot input1list { $$=$2; }
	| opnot input2list { $$=$2; }
	| opnot input3list { $$=$2; }
	;
equentry: op NAME NAME telos { HandleEQL($2,$3); $$=$3; }
	;
telos	: ENDUM { $$= $1;}
	;
result	: NAME { $$= $1;}
	;
opnot	: NOTEQL { fprintf(ftmp, "%c ", $1); $$= $1;}
	;
op	: EQL { $$= $1;}
	;
input1list : NAME result telos
	{ fprintf(ftmp, "%s %s\n", $1, $2); $$=$2; }
	;
input2list : NAME NAME result telos
	{ fprintf(ftmp, "%s %s %s\n", $1, $2, $3); $$=$3; }
	;
input3list : NAME NAME NAME result telos
	{ fprintf(ftmp, "%s %s %s %s\n", $1, $2, $3, $4); $$=$4; }
	;
sentry	: seqop dtinput seqout telos 
	{ fprintf(ftmp, "%s\n", $3); $$=$3; }
	| seqdop jrinput seqout telos
	{ fprintf(ftmp, "%s\n", $3); $$=$3; }
	;
dtinput	: sequin clock 
	{ fprintf(ftmp, "%s %s ", $1, $2); $$=$2; }
	;
jrinput	: sequin sequin clock 
	{ fprintf(ftmp, "%s %s %s ", $1, $2, $3); $$=$3; }
	;
sequin	: NAME { $$=$1; }
	;
clock	: NAME { $$=$1; }
	;
seqop	: SNOTEQL1 { fprintf(ftmp, "%s ", $1); $$=$1; }
	;
seqdop	: SNOTEQL2 { fprintf(ftmp, "%s ", $1); $$=$1; }
	;
seqout	: NAME { $$=$1; }
	;
declentry: INDECL NAME telos { fprintf(ftmp,"in %s\n",$2); } |
           OUTDECL NAME telos { fprintf(ftmp,"out %s\n",$2); } |
           CLKDECL NAME telos { fprintf(ftmp,"clk %s\n",$2); };
%%
#include "lex.yy.c"

/**********************************************************************/

extern char *last_token;
int yyerror()
{
	fprintf(stderr,"pif preprocessor error at token %s.\n",last_token);
	exit(1);
}

/**********************************************************************/

main(argc,argv)
int	argc;
char	*argv[];
{
	EqlEntry	*q, *p;
	char	c, s[100];
	extern FILE	*fin, *ftmp;

	ftmp= fopen(argv[2],"w");
	yyparse();
	fclose(ftmp);
/* PRINTALL() prints out the pairs of equivalent nets */
/*
	printall();
*/
	fin= fopen(argv[1],"w");
	ftmp= fopen(argv[2],"r");
	while (!feof(ftmp))
	{
		c= ' ';
		while ((c==' ')||(c=='\t'))	c= getc(ftmp);
		if (c=='\n')	fprintf(fin,"\n");
			else	ungetc(c, ftmp);
		fscanf(ftmp, "%s", s);
		if ( (q= FindEql(s))==(EqlEntry *)0 )
				fprintf(fin, "%s ", s);
		else
		{
			if ( (p= FindEql(q->newname))==(EqlEntry *)0 )
				fprintf(fin, "%s ", q->newname);
			else	fprintf(fin, "%s ", p->newname);
		}
		s[0]= '\0';
	}
	fclose(fin);
	fclose(ftmp);
}

/*******************************************************/
