#!/bin/sh
# Translates PDL C program into a PIF netlist.
#
ifile=`basename $1 .pdl`
atemp=/tmp/pif2oct$$
trap "rm -f ${ifile}.c $atemp ${ifile}.exe" 0 1 2 3 9 15

# This variable is set by a sed operation during installation.
lib=__CADROOT__/lib/pdl++

if [ ! -r ${ifile}.pdl ]; then
	echo "File ${ifile}.pdl does not exist"
	exit 1
fi
cp ${ifile}.pdl ${ifile}.c
__CC__ __CFLAGS__ -I${lib} ${ifile}.c ${lib}/pdl++.o -o ${ifile}.exe 
${ifile}.exe $2 $3 $4 $5 > $atemp
mv $atemp ${ifile}.pif
