#!/bin/sh
# Translates PDL C program into a PIF netlist.
#
ifile=`basename $1 .pdl`
trap "rm -f ${ifile}.c ${ifile}.exe" 0 1 2 3 9 15

# This variable is set by a sed operation during installation.
lib=/u/cad/lib/pif

if [ ! -r ${ifile}.pdl ]; then
	echo "File ${ifile}.pdl does not exist"
	exit 1
fi
cp ${ifile}.pdl ${ifile}.c
cc -I${lib} ${ifile}.c -o ${ifile}.exe
${ifile}.exe > ${ifile}.pif
