#include	<stdio.h>
#include	<strings.h>

typedef	char	wire;
wire	*emalloc();
wire	*GetWire();

wire	*INV(), *AND(), *AND3(), *OR(), *OR3(), *XOR(), *DLATCH(), *ADDER();

char	*malloc();

/*********************************************************/

static	int	wireno= 0;

/*********************************************************/

wire	*GetWire()
{
	char	*strnum;
	char	zero= '0';
	int	x= 0, y= 0, m= 10, i;
	int	nwireno;

	wireno++;
	while (wireno>x)
	{
		x= (x+1)*10-1;
		y++;
	}
	strnum= emalloc( (y+2)*sizeof( char ) );
	strnum[0]= 'w';
	strnum[y+1]= '\0';
	nwireno= wireno;
	for ( i= y; i>= 1; i-- )
	{
		strnum[i]= nwireno%m+zero;
		nwireno= nwireno/10;
	}
	return strnum;
}

/*********************************************************/

wire	*NameWire(x)
char	*x;
{
	char	*strnum;

	strnum= emalloc( (strlen(x)+1)*sizeof(char) );
	strcpy(strnum,x);
	return strnum;
}

/*******************************************************/

char	*emalloc(n)
unsigned	n;
{
	char	*p, *malloc();

	p= malloc(n);
	if ( p==0 )
	{
		printf("Out of Memory; malloc() failed.\n");
		exit(1);
	}
	return p;
}

/*********************************************************/

wire	*INV(x)
wire	*x;
{
	wire	*z;

	z= GetWire();
	printf("! %s %s\n", x, z);
	return z;
}

/*********************************************************/

wire	*AND(x,y)
wire	*x, *y;
{
	wire	*z;

	z= GetWire();
	printf("& %s %s %s\n", x, y, z);
	return z;
}

/*********************************************************/

wire	*AND3(x,y,z)
wire	*x, *y, *z;
{
	wire	*w;

	w= GetWire();
	printf("& %s %s %s %s\n", x, y, z, w);
	return w;
}

/*********************************************************/

wire	*OR(x,y)
wire	*x, *y;
{
	wire	*z;

	z= GetWire();
	printf("+ %s %s %s\n", x, y, z);
	return z;
}

/*********************************************************/

wire	*OR3(x,y,z)
wire	*x, *y, *z;
{
	wire	*w;

	w= GetWire();
	printf("+ %s %s %s %s\n", x, y, z, w);
	return w;
}

/*********************************************************/

wire	*NAND(x,y)
wire	*x, *y;
{
	wire	*z;

	z= GetWire();
	printf("$ %s %s %s\n", x, y, z);
	return z;
}

/*********************************************************/

wire	*NAND3(x,y,z)
wire	*x, *y, *z;
{
	wire	*w;

	w= GetWire();
	printf("$ %s %s %s %s\n", x, y, z, w);
	return w;
}

/*********************************************************/

wire	*NOR(x,y)
wire	*x, *y;
{
	wire	*z;

	z= GetWire();
	printf("# %s %s %s\n", x, y, z);
	return z;
}

/*********************************************************/

wire	*NOR3(x,y,z)
wire	*x, *y, *z;
{
	wire	*w;

	w= GetWire();
	printf("# %s %s %s %s\n", x, y, z, w);
	return w;
}

/*********************************************************/

wire	*XOR(x,y)
wire	*x, *y;
{
	wire	*z;

	z= GetWire();
	printf("@ %s %s %s\n", x, y, z);
	return z;
}

/*********************************************************/

wire	*DLATCH(x,y)
wire	*x, *y;
{
	wire	*z;

	z= GetWire();
	printf("d %s %s %s\n", x, y, z);
	return z;
}

/*********************************************************/

wire	*EQL(x,y)
wire	*x, *y;
{
	printf("= %s %s\n", x, y);
	return x;
}

/*********************************************************/

wire	*ADDER(x,y,c)
wire	*x, *y, *c;
{
	wire	*z1, *z2, *z3, *zs, *zc;

	z1= GetWire();
	printf("@ %s %s %s\n", x, y, z1);
	zs= GetWire();
	printf("@ %s %s %s\n", z1, c, zs);
	z2= GetWire();
	printf("& %s %s %s\n", z1, c, z2);
	z3= GetWire();
	printf("& %s %s %s\n", x, y, z3);
	zc= GetWire();
	printf("+ %s %s %s\n", z3, z2, zc);
	return zc;
}

/*********************************************************/

